//Convertor.cc

#include <interface/Alert.h>
#include <storage/Directory.h>

#include <support/UTF8.h>
#include <string.h>
#include <stdio.h>
#include <support/Beep.h>
#include "Convertor.h"
#include "extensions.h"


Convertor::Convertor()
{
}

Convertor::~Convertor()
{
	
}

void Convertor::Convert(BFile *infile, int source_enc, int dest_enc, entry_ref *dir_ref, entry_ref *file_ref)
{
	int32 length;
	int32 dest_len = 65536;
	int32 dest_len2 = 65536;
	int32 state = 0;
	int32 state2 = 0;
	
	char outname[256];
	char mime[256];
	BFile *outfile = new BFile;
	BDirectory dir(dir_ref);
	
	if(source_enc != dest_enc)
	{	
		strcpy(outname, file_ref->name);
		strcat(outname, extensions[dest_enc]);
		if(dir.CreateFile(outname, outfile) == B_OK)				
		{
			infile->ReadAttr("BEOS:TYPE", B_STRING_TYPE, 0, mime, 256);
			outfile->WriteAttr("BEOS:TYPE", B_STRING_TYPE, 0, mime, 256);
		
			if(source_enc == 0) //if source is UTF8
			{	
				while((length = infile->Read(inbuffer, 65536)))
				{	
					convert_from_utf8(dest_enc - 1, inbuffer, &length, outbuffer, &dest_len, &state);
					outfile->Write(outbuffer, dest_len);
				}
			}
			
			else if(dest_enc == 0) //if destination is UTF8
			{
				while((length = infile->Read(inbuffer, 65536)))
				{
					convert_to_utf8(source_enc - 1, inbuffer, &length, outbuffer, &dest_len, &state);
					outfile->Write(outbuffer, dest_len);
				}		
			}
		
			else          //convert in 2 steps with UTF8 as middle repr.
			{
				while((length = infile->Read(inbuffer, 65536)))
				{
					convert_to_utf8(source_enc - 1, inbuffer, &length, midbuffer, &dest_len, &state);
					convert_from_utf8(dest_enc -1 , midbuffer, &dest_len, outbuffer, &dest_len2, &state2);
					outfile->Write(outbuffer, dest_len2);
				}	
			}
		}
		delete outfile;
	}
}		