//TextConvertWindow.cc

#include <support/Beep.h>
#include <interface/GraphicsDefs.h>

#include "TextConvertView.h"
#include <stdio.h>

TextConvertView::TextConvertView(int fontheight) : BView(BRect(0,0,
															 20 * fontheight, 8 * fontheight), 
													"TextConvertView",
													B_FOLLOW_LEFT | B_FOLLOW_TOP,
													B_NAVIGABLE | B_WILL_DRAW)
{

	
	
	// set background color
	SetViewColor(220, 220, 220, 0);
	
	//set-up source encoding select menu
	
	source_select_menu = new BMenu("UTF8");
	AddItems(source_select_menu, MSG_SOURCE_SELECT);
	source_select_menu->SetLabelFromMarked(true);
	(source_select_menu->ItemAt(0))->SetMarked(true);

	source_select = new BMenuField(BRect(10,10, 10 + fontheight * 16, 
										 10 + fontheight * 2),
								  "Encoding menu",
								  "Convert from:", source_select_menu);
	AddChild(source_select);							  
	
	
	
	//set-up source encoding select menu
	
	dest_select_menu = new BMenu("UTF8");

	AddItems(dest_select_menu, MSG_DEST_SELECT);
	
	dest_select_menu->SetLabelFromMarked(true);
	(dest_select_menu->ItemAt(0))->SetMarked(true);

	dest_select = new BMenuField(BRect(10, 10 + fontheight * 2, 
									   10 + fontheight * 16, 
									   10 + fontheight * 4),
								  "Encoding menu",
								  "Convert to:", dest_select_menu);
	AddChild(dest_select);							  
	
	
	// action button for converting

	
	convert = new BButton(BRect(10,10 + fontheight * 4,10 + fontheight * 6,10 + fontheight * 6),
								 "Comnvert button",
								 "Convert",
								  new BMessage(MSG_CONVERT));
								 
	AddChild(convert);
	
	cancel = new BButton(BRect(10 + fontheight * 7,10 + fontheight * 4,10 + fontheight * 13 ,10 + fontheight * 6),
								"Cancel button",
								"Cancel",
								new BMessage(MSG_CANCEL));
								
	AddChild(cancel);
	
}

TextConvertView::~TextConvertView()
{
	delete source_select;
	delete dest_select;
	delete convert;
	delete cancel;
}


void TextConvertView::AddItems(BMenu *menu, int32 id)
{
	menu->AddItem(new BMenuItem("UTF8", new BMessage(id)));
	menu->AddItem(new BMenuItem("Western European (ISO 8859-1)", new BMessage(id)));
	menu->AddItem(new BMenuItem("Central European (ISO 8859-2)", new BMessage(id)));
	menu->AddItem(new BMenuItem("South European (ISO 8859-3)", new BMessage(id)));
	menu->AddItem(new BMenuItem("Baltic (ISO 8859-4)", new BMessage(id)));
	menu->AddItem(new BMenuItem("Cyrillic (ISO 8859-5)", new BMessage(id)));
	menu->AddItem(new BMenuItem("Arabic (ISO 8859-6)", new BMessage(id)));
	menu->AddItem(new BMenuItem("Greek (ISO 8859-7)", new BMessage(id)));
	menu->AddItem(new BMenuItem("Hebrew (ISO 8859-8)", new BMessage(id)));
	menu->AddItem(new BMenuItem("Turkish (ISO 8859-9)", new BMessage(id)));
	menu->AddItem(new BMenuItem("Nordic (ISO 8859-10)", new BMessage(id)));
	menu->AddItem(new BMenuItem("Macintosh Roman", new BMessage(id)));
	menu->AddItem(new BMenuItem("Japanese (Shift JIS)", new BMessage(id)));
	menu->AddItem(new BMenuItem("Japanese (EUC-JP)", new BMessage(id)));
	menu->AddItem(new BMenuItem("Japanese (JIS X 0208-1990)", new BMessage(id)));
	menu->AddItem(new BMenuItem("MS Windows codepage 1252", new BMessage(id)));
	menu->AddItem(new BMenuItem("Unicode 2.0", new BMessage(id)));
	menu->AddItem(new BMenuItem("Cyrillic (KOI8-R)", new BMessage(id)));
	menu->AddItem(new BMenuItem("MS Windows codepage 1251", new BMessage(id)));
	menu->AddItem(new BMenuItem("MS DOS codepage 866", new BMessage(id)));
}
	