//TextConvertWindow.cc

#include <Window.h>
#include <support/Beep.h>

#include "TextConvertWindow.h"



TextConvertWindow::TextConvertWindow(entry_ref dir_ref, BMessage *msg, int fontheight) : 
							BWindow(BRect(200,200,200 + 20 * fontheight , 200 + 8 * fontheight),
								"TextConvert", B_TITLED_WINDOW, 
								B_NOT_RESIZABLE | B_NOT_ZOOMABLE)
{	
	// default encoding is utf8
	source_enc = 0;
	dest_enc = 0;

	saved_ref = dir_ref;
	saved_msg = new BMessage();
	*saved_msg = *msg;
				
	view = new TextConvertView(fontheight);
	AddChild(view);
	Show();
	
	
}

TextConvertWindow::~TextConvertWindow()
{
	
}

void TextConvertWindow::MessageReceived(BMessage *message)
{
	entry_ref file_ref;
	int refs;
	
	switch (message->what)
	{
	case MSG_CONVERT:
		
		
		for(refs = 0 ; saved_msg->FindRef("refs", refs, &file_ref) == B_NO_ERROR ; refs++)
		{
			in = new BFile(&file_ref, B_READ_ONLY);
			convertor.Convert(in, source_enc, dest_enc, &saved_ref, &file_ref);
		}
		
		
		// kill this window when done
		
		Quit();
		break;
	case MSG_CANCEL:
		Quit();
		break;	
		
	case MSG_SOURCE_SELECT:
		
		message->FindInt32((const char *)"index", (int32 *)&source_enc);
		break;
	case MSG_DEST_SELECT:
		message->FindInt32((const char *)"index", (int32 *)&dest_enc);
		break;	
	
	default:
		BWindow::MessageReceived(message);
		break;
	}
}

bool TextConvertWindow::QuitRequested()
{
	
	BWindow::QuitRequested();
	return true;
}

